using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;

namespace CM_Toolbox
{
    public class CMConfig
    {
        public String fileName = "";
        public void SetPath(string path)
        {
            if (!(path.EndsWith("\\")))
            {
                path = path + "\\";
            }
            fileName = path + "CMConfig.xml";
        }
        public bool Exists()
        {

            FileInfo configFile = new FileInfo(fileName);
            if (configFile.Exists)
            {
                return (true);
            }
            else
            {
                return (false);
            }
            
                        
        }

        //Methods for individual values
        //'get' methods are used to retrieve data from configuration file
       
        //get the SOAP server URL
        public string getTTURLFromFile()
        {
            string ttURL = "";
            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(fileName);
                mCurrentNode = mDocument.DocumentElement;

                mCurrentNode = mCurrentNode.SelectSingleNode("//TTServerAddress");
                ttURL = mCurrentNode.InnerText;

               
            }
            catch (Exception f)
            {
                Logger.WriteLine("Error retrieving the TestTrack SOAP URL form the configuration file:\n" + f.Message);
            }
            return (ttURL);
            
        }
        public string getSSCMServerFromFile()
        {
            string scmSrvAddress = "";
            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(fileName);
                mCurrentNode = mDocument.DocumentElement;

                mCurrentNode = mCurrentNode.SelectSingleNode("//SCMServerAddress");
                scmSrvAddress = mCurrentNode.InnerText;


            }
            catch (Exception f)
            {
                Logger.WriteLine("Error retrieving the Surround SCM server address form the configuration file:\n" + f.Message);
            }
            return (scmSrvAddress);

        }
        public string getSSCMPortFromFile()
        {
            string scmSrvPort = "";
            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(fileName);
                mCurrentNode = mDocument.DocumentElement;

                mCurrentNode = mCurrentNode.SelectSingleNode("//SCMServerPort");
                scmSrvPort = mCurrentNode.InnerText;


            }
            catch (Exception f)
            {
                Logger.WriteLine("Error retrieving the Surround SCM server address form the configuration file:\n" + f.Message);
            }
            return (scmSrvPort);

        }
                
        public string getUserNameFromFile()
        {
            string ttUserName = "";

            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(fileName);
                mCurrentNode = mDocument.DocumentElement;
                mCurrentNode = mCurrentNode.SelectSingleNode("//UserName");
                ttUserName = mCurrentNode.InnerText;
            }
            catch (Exception f)
            {
                Logger.WriteLine("Error retrieving the TestTrack user name form the configuration file:\n" + f.Message);
            }
            return (ttUserName);
        }

        public string getPasswordFromFile()
        {
            string ttPassword = "";

            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(fileName);
                mCurrentNode = mDocument.DocumentElement;
                mCurrentNode = mCurrentNode.SelectSingleNode("//Password");
                ttPassword = mCurrentNode.InnerText;
            }
            catch (Exception f)
            {
                Logger.WriteLine("Error retrieving the TestTrack password form the configuration file:\n" + f.Message);
            }
            return (ttPassword);
        }
    }
}
